Subject: Re: [PATCH] net: Fix IP_MULTICAST_IF

From: Eric Dumazet <[email-masked]>
Date: Tue, 20 Oct 2009 06:23:54 +0200

David Miller a écrit :
> From: Eric Dumazet <[email-masked]>
> Date: Tue, 20 Oct 2009 06:07:48 +0200
> 
>> Final target might be fine, but an element in the chain, before target
>> could be deleted while reader scans hash chain.
>  ...
>> So it should visit a nice memory location ?
> 
> It should hit a NULL eventually and deterministically even if an
> unlink happens at the same time..... unless the object gets free'd
> meanwhile, hmmm...
> 
> This code is definitely intentional, I remember when I added it to
> the tree, Alexey wrote it :-)

I wonder if the whole thing could use RCU somehow, since some workloads hit
this dev_base_lock rwlock pretty hard...